diff --git a/envy24control/volume.c b/envy24control/volume.c
index 4386e35..ffc3086 100644
--- a/envy24control/volume.c
+++ b/envy24control/volume.c
@@ -20,6 +20,7 @@
  *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
  */
 
+#include <math.h>
 #include "envy24control.h"
 
 #define toggle_set(widget, state) \
@@ -209,26 +210,195 @@ void adc_sense_update(int idx)
 	toggle_set(av_adc_sense_radio[idx][state], TRUE);
 }
 
+/*
+ */
+
+static char temp_label[16];
+
+/*
+ * NPM: Per Fons Adriaensen''s message to linux-audio-user's list
+ * July 2010 ( http://www.linuxaudio.org/mailarchive/lad/2010/7/13/171540 )
+ * "L dB (L < 0) corresponds to 255 * (10 ^ L / 20)"
+ * Alternately: http://en.wikipedia.org/wiki/Decibel#Field_quantities
+ * 20 log10(V1/V0) where V1 is voltage measured and V0 is reference.
+ * ... of course, the value of the digital peak meters isn't the "voltage"
+ * for example an output of 1/255 --> −48.130803609dB
+ * whereas 255/255 --> 0dB
+ *         254/255 --> −0.034129276
+ *         250/255 --> −0.172003435
+ * http://alsa.cybermirror.org/manuals/icensemble/envy24.pdf states 
+ * "Peak data derived from the absolute value of 9 msb.
+ *  00h min - FFh max volume. Reading the register
+ *  resets the meter to 00h."
+ */
+char* peak_level_to_db(int ival) {
+  if (ival != 0) {
+    double value = 20.0 * log10((double)ival/(double)MAX_METERING_LEVEL);
+    //"(Off)"
+    //"0dBFS" <-- seems to cause a resize oscillation, use 0.0dB instead
+    //"0.0dB"
+    //"-0.10"      
+    //"-9.90"
+    //"-48.0"
+    if (value == 0.0)
+      sprintf(temp_label, "0.0dB");
+    else if (value > -10.0)
+      sprintf(temp_label, "%+1.2f", value);
+    else
+      sprintf(temp_label, "%+2.1f", value);
+    return (temp_label);
+  }
+  else
+    return ("(Off)");
+}
 
 /*
+ * NPM: "subroutine" used twice in create_mixer_frame() to draw markings
+ * for each digital mixer input attenuation slider.  Each slider is drawn
+ * optionally with or without a legend describing the dBs attenuation at
+ * the given level.  Each slider controls attentuation of its input from
+ * +0dB to -144.0dB (and "Off").
  */
+void draw_24bit_attenuator_scale_markings(GtkScale *scale, GtkPositionType position, int draw_legend_p) {
+  if (!no_scale_marks) {
+    gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE,
+		       position, draw_legend_p ? "<span color='green' size='x-small'>+0</span>": NULL);
+    gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE+1*MIXER_ATTENUATOR_STEP_SIZE,
+		       position, draw_legend_p ? "<span color='blue' size='x-small'>-12</span>" : NULL);
+    gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE+2*MIXER_ATTENUATOR_STEP_SIZE,
+		       position, draw_legend_p ? "<span color='blue' size='x-small'>-24</span>" : NULL);
+    gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE+3*MIXER_ATTENUATOR_STEP_SIZE,
+		       position, draw_legend_p ? "<span color='blue' size='x-small'>-36</span>" : NULL);
+    gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE+4*MIXER_ATTENUATOR_STEP_SIZE,
+		       position, draw_legend_p ? "<span color='blue' size='x-small'>-48</span>" : NULL);
+    gtk_scale_add_mark(scale, (float) LOW_MIXER_ATTENUATION_VALUE,
+		       position, NULL); /* NPM: last marker needs to not be a label, else the last level gets placed incorrectly (gtk2-2.18.9-3.fc12.x86_64 bug?) */
+
+//    gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE,
+//		       position, draw_legend_p ? "<span color='green' size='x-small'>+0</span>": NULL);
+//    gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE+1*MIXER_ATTENUATOR_STEP_SIZE,
+//		       position, draw_legend_p ? "<span color='blue' size='x-small'>-18</span>" : NULL);
+//    gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE+2*MIXER_ATTENUATOR_STEP_SIZE,
+//		       position, draw_legend_p ? "<span color='blue' size='x-small'>-36</span>" : NULL);
+//    gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE+3*MIXER_ATTENUATOR_STEP_SIZE,
+//		       position, draw_legend_p ? "<span color='blue' size='x-small'>-54</span>" : NULL);
+//    //  gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE+4*MIXER_ATTENUATOR_STEP_SIZE,
+//    //		     position, draw_legend_p ? "<span color='blue' size='x-small'>-72</span>" : NULL);
+//    gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE+5*MIXER_ATTENUATOR_STEP_SIZE,
+//		       position, draw_legend_p ? "<span color='blue' size='x-small'>-90</span>" : NULL);
+//    //  gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE+6*MIXER_ATTENUATOR_STEP_SIZE,
+//    //		     position, draw_legend_p ? "<span color='blue' size='x-small'>-108</span>" : NULL);
+//    gtk_scale_add_mark(scale, (float) MIN_MIXER_ATTENUATION_VALUE+7*MIXER_ATTENUATOR_STEP_SIZE,
+//		       position, draw_legend_p ? "<span color='blue' size='x-small'>-126</span>" : NULL);
+//    gtk_scale_add_mark(scale, (float) MAX_MIXER_ATTENUATION_VALUE,
+//		       position, NULL); /* NPM: last marker needs to not be a label, else the last level gets placed incorrectly (gtk2-2.18.9-3.fc12.x86_64 bug?) */
+  }
+}
+
+/* NPM: used in create_analog_volume() to draw dB markings on DAC attenuators */
+void draw_dac_scale_markings(GtkScale *scale, GtkPositionType position) {
+  if (!no_scale_marks) {
+  gtk_scale_add_mark(scale, (float) -envy_dac_max(),
+		     position, "<span color='green' size='x-small'>+0</span>");
+  gtk_scale_add_mark(scale, (float) -envy_dac_max()+1*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-6</span>");
+  gtk_scale_add_mark(scale, (float) -envy_dac_max()+2*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-12</span>");
+  gtk_scale_add_mark(scale, (float) -envy_dac_max()+3*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-18</span>");
+  gtk_scale_add_mark(scale, (float) -envy_dac_max()+4*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-24</span>");
+  gtk_scale_add_mark(scale, (float) -envy_dac_max()+5*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-30</span>");
+  gtk_scale_add_mark(scale, (float) -envy_dac_max()+6*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-36</span>");
+//  gtk_scale_add_mark(scale, (float) -envy_dac_max()+7*ANALOG_GAIN_STEP_SIZE,
+//		     position, "<span color='blue' size='x-small'>-42</span>");
+  gtk_scale_add_mark(scale, (float) -envy_dac_max()+8*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-48</span>");
+//  gtk_scale_add_mark(scale, (float) -envy_dac_max()+9*ANALOG_GAIN_STEP_SIZE,
+//		     position, "<span color='blue' size='x-small'>-54</span>");
+  gtk_scale_add_mark(scale, (float) -envy_dac_max()+10*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-60</span>");
+  gtk_scale_add_mark(scale, (float) 0,
+		     position, NULL); /* NPM: last marker needs to not be a label, else the last level gets placed incorrectly (gtk2-2.18.9-3.fc12.x86_64 bug?) */
+  }
+}
+
+/* NPM: used in create_analog_volume() to draw dB markings on ADC attenuators/amplifiers */
+void draw_adc_scale_markings(GtkScale *scale, GtkPositionType position) {
+  if (!no_scale_marks) {
+  gtk_scale_add_mark(scale, (float) -envy_adc_max(),
+		     position, "<span color='red' size='x-small'>+18</span>");
+  gtk_scale_add_mark(scale, (float) -envy_adc_max()+1*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='red' size='x-small'>+12</span>");
+  gtk_scale_add_mark(scale, (float) -envy_adc_max()+2*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='red' size='x-small'>+6</span>");
+  gtk_scale_add_mark(scale, (float) -envy_adc_max()+3*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='green' size='x-small'>+0</span>");
+  gtk_scale_add_mark(scale, (float) -envy_adc_max()+4*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-6</span>");
+  gtk_scale_add_mark(scale, (float) -envy_adc_max()+5*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-12</span>");
+//  gtk_scale_add_mark(scale, (float) -envy_adc_max()+6*ANALOG_GAIN_STEP_SIZE,
+//		     position, "<span color='blue' size='x-small'>-18</span>");
+  gtk_scale_add_mark(scale, (float) -envy_adc_max()+7*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-24</span>");
+//  gtk_scale_add_mark(scale, (float) -envy_adc_max()+8*ANALOG_GAIN_STEP_SIZE,
+//		     position, "<span color='blue' size='x-small'>-30</span>");
+  gtk_scale_add_mark(scale, (float) -envy_adc_max()+9*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-36</span>");
+//  gtk_scale_add_mark(scale, (float) -envy_adc_max()+10*ANALOG_GAIN_STEP_SIZE,
+//		     position, "<span color='blue' size='x-small'>-42</span>");
+  gtk_scale_add_mark(scale, (float) -envy_adc_max()+11*ANALOG_GAIN_STEP_SIZE,
+		     position, "<span color='blue' size='x-small'>-48</span>");
+//  gtk_scale_add_mark(scale, (float) -envy_adc_max()+12*ANALOG_GAIN_STEP_SIZE,
+//		     position, "<span color='blue' size='x-small'>-54</span>");
+//  gtk_scale_add_mark(scale, (float) -envy_adc_max()+13*ANALOG_GAIN_STEP_SIZE,
+//		     position, "<span color='blue' size='x-small'>-60</span>");
+  gtk_scale_add_mark(scale, (float) 0,
+		     position, NULL); /* NPM: last marker needs to not be a label, else the last level gets placed incorrectly (gtk2-2.18.9-3.fc12.x86_64 bug?) */
+  }
+}
 
 void dac_volume_adjust(GtkAdjustment *adj, gpointer data)
 {
 	int idx = (int)(long)data;
 	snd_ctl_elem_value_t *val;
 	int err, ival = -(int)adj->value;
-	char text[16];
 
 	snd_ctl_elem_value_alloca(&val);
 	snd_ctl_elem_value_set_interface(val, SND_CTL_ELEM_IFACE_MIXER);
 	snd_ctl_elem_value_set_name(val, DAC_VOLUME_NAME);
 	snd_ctl_elem_value_set_index(val, idx);
 	snd_ctl_elem_value_set_integer(val, 0, ival);
-	sprintf(text, "%03i", ival);
-	gtk_label_set_text(av_dac_volume_label[idx], text);
-	if ((err = snd_ctl_elem_write(ctl, val)) < 0)
-		g_print("Unable to write dac volume: %s\n", snd_strerror(err));
+
+	if ((err = snd_ctl_elem_write(ctl, val)) < 0) {
+	  g_print("Unable to write dac volume: %s\n", snd_strerror(err));
+	  sprintf(temp_label, "(Err)");
+	}
+	else if (ival == 0) {
+	  sprintf(temp_label, "(Off)");
+	}
+	else {
+	  /* NPM: changed to output dB values. Use of proper ALSA API
+	     snd_ctl_convert_to_dB() to return dB values suggested by
+	     Tim E. Real on linux-audio-devel list. */
+	  snd_ctl_elem_id_t *elem_id;
+	  snd_ctl_elem_id_alloca(&elem_id);
+	  snd_ctl_elem_id_set_interface(elem_id, SND_CTL_ELEM_IFACE_MIXER);
+	  snd_ctl_elem_id_set_name(elem_id, DAC_VOLUME_NAME);
+	  snd_ctl_elem_id_set_index(elem_id, idx); // TER: Added
+	  long db_gain = 0;
+	  snd_ctl_convert_to_dB(ctl, elem_id, ival, &db_gain); /* convert ival integer to dB */
+	  float fval = ((float)db_gain / 100.0);
+	  if (fval <= -10)
+	    sprintf(temp_label, "%+2.1f", fval);
+	  else
+	    sprintf(temp_label, "%+2.1f ", fval);
+	}
+
+	gtk_label_set_text(GTK_LABEL(av_dac_volume_label[idx]), temp_label);
 }
 
 void adc_volume_adjust(GtkAdjustment *adj, gpointer data)
@@ -236,17 +406,43 @@ void adc_volume_adjust(GtkAdjustment *adj, gpointer data)
 	int idx = (int)(long)data;
 	snd_ctl_elem_value_t *val;
 	int err, ival = -(int)adj->value;
-	char text[16];
 
 	snd_ctl_elem_value_alloca(&val);
 	snd_ctl_elem_value_set_interface(val, SND_CTL_ELEM_IFACE_MIXER);
 	snd_ctl_elem_value_set_name(val, ADC_VOLUME_NAME);
 	snd_ctl_elem_value_set_index(val, idx);
 	snd_ctl_elem_value_set_integer(val, 0, ival);
-	sprintf(text, "%03i", ival);
-	gtk_label_set_text(av_adc_volume_label[idx], text);
-	if ((err = snd_ctl_elem_write(ctl, val)) < 0)
-		g_print("Unable to write adc volume: %s\n", snd_strerror(err));
+
+	if ((err = snd_ctl_elem_write(ctl, val)) < 0) {
+	  g_print("Unable to write adc volume: %s\n", snd_strerror(err));
+	  sprintf(temp_label, "(Err)");
+	}
+	else if (ival == 0) {
+	  sprintf(temp_label, "(Off)");
+	}
+	else {
+	/* NPM: changed to output dB values. Use of proper ALSA API
+	   snd_ctl_convert_to_dB() to return dB values suggested by
+	   Tim E. Real on linux-audio-devel list. */
+	  snd_ctl_elem_id_t *elem_id;
+	  snd_ctl_elem_id_alloca(&elem_id);
+	  snd_ctl_elem_id_clear(elem_id);
+	  snd_ctl_elem_id_set_interface(elem_id, SND_CTL_ELEM_IFACE_MIXER);
+	  snd_ctl_elem_id_set_name(elem_id, ADC_VOLUME_NAME);
+	  long db_gain = 0;
+	  snd_ctl_convert_to_dB(ctl, elem_id, ival, &db_gain);
+	  float fval = ((float)db_gain / 100.0);
+	  if (fval >= 10)
+	    sprintf(temp_label, "%+2.1f", fval);
+	  else if (fval > 0)
+	    sprintf(temp_label, "%+2.1f ", fval);
+	  else if (fval <= -10)
+	    sprintf(temp_label, "%+2.1f", fval);
+	  else
+	    sprintf(temp_label, "%+2.1f ", fval);
+	}
+
+	gtk_label_set_text(GTK_LABEL(av_adc_volume_label[idx]), temp_label);
 }
 
 void ipga_volume_adjust(GtkAdjustment *adj, gpointer data)
@@ -262,7 +458,7 @@ void ipga_volume_adjust(GtkAdjustment *adj, gpointer data)
 	snd_ctl_elem_value_set_index(val, idx);
 	snd_ctl_elem_value_set_integer(val, 0, ival);
 	sprintf(text, "%03i", ival);
-	gtk_label_set_text(av_ipga_volume_label[idx], text);
+	gtk_label_set_text(GTK_LABEL(av_ipga_volume_label[idx]), text);
 	if ((err = snd_ctl_elem_write(ctl, val)) < 0)
 		g_print("Unable to write ipga volume: %s\n", snd_strerror(err));
 }
